(function (d3) {
  
  const svg = d3.select('svg');

	const width = +svg.attr('width');
	const height = +svg.attr('height');
	var margin = {
  	left: 80,
  	top: 10,
  	bottom: 100,
  	right: 10,
	};
  
  const x = d3.scaleBand().range([
  margin.left,
  width - margin.right - margin.right,
	]);
	var xAx = svg
    .append('g')
    .attr(
      'transform',
      'translate(' + margin.left + ',0)'
    );

  const y = d3.scaleLinear().range([
    height - margin.bottom,
    margin.top,
  ]);
  var yAx = svg
    .append('g')
    .attr(
      'transform',
      'translate(' + margin.left + ',0)'
  );
  
  
  /*const update = (data) => {    
  x.domain(data.map((d) => d.dateRelease));
  xAx
    .call(d3.axisBottom(x))
    .attr('transform', 'translate(0, 410)')
    .selectAll('text')
    .style('text-anchor', 'end')
    .attr('dx', '-1em')
    .attr('dy', '-0.5em')
    .attr('transform', 'rotate(-60)');
	
  y.domain([0, d3.max(data, (d) => d.deezerFans)]);
    
  yAx.call(d3.axisLeft(y).tickSize(-width));
    
  // group the data: I want to draw one line per group
  var sumstat = d3.nest() // nest function allows to group the calculation per level of a factor
    .key(function(d) { return d.genre;})
    .entries(data);
    
  var res = sumstat.map(function(d){ return d.genre }) // list of group names
  var color = d3.scaleOrdinal()
    .domain(res)
    .range(['#e41a1c','#377eb8','#4daf4a','#984ea3','#ff7f00','#ffff33','#a65628','#f781bf','#999999'])

  
  svg.selectAll(".line")
      .data(sumstat)
      .enter()
      .append("path")
        .attr("fill", "none")
    		//couleur des lignes
        .attr("stroke", function(d){ return color(d.genre) })
        //épaisseur des lignes
    		.attr("stroke-width", 1.5)
        .attr("d", function(d){
          return d3.line()
            .x(function(d) { return x(d.dateRelease); })
            .y(function(d) { return y(+d.deezerFans); })
            (d.values)
        })
	};*/
  
  
  
  const update = (data) => {    
    
   
    
  x.domain(data.map((d) => d
                    .dates[0]
                    .date));
  xAx
    .call(d3.axisBottom(x))
    .attr('transform', 'translate(0, 410)')
    .selectAll('text')
    .style('text-anchor', 'end')
    .attr('dx', '-1em')
    .attr('dy', '-0.5em')
    .attr('transform', 'rotate(-60)');
	
  y.domain([0, d3.max(data, (d) => d
                      .dates [0]
                      .nb_musique)]);
    
  yAx.call(d3.axisLeft(y).tickSize(-width));
    
  // group the data: I want to draw one line per group
  var sumstat = d3.nest() // nest function allows to group the calculation per level of a factor
    .key(function(d) {
          //console.log("sum : " + d.genre);
      return d.genre;})
    .entries(newData);
    
    
    
  var res = sumstat.map(function(d){
    //console.log("res : " + d.key);
    return d.key }) // list of group names
  var color = d3.scaleOrdinal()
    .domain(res)
    .range(['#e41a1c','#377eb8','#4daf4a','#984ea3','#ff7f00','#ffff33','#a65628','#f781bf','#999999'])

  
  
    
  svg.selectAll(".line")
      .data(sumstat)
      .enter()
      .append("path")
        .attr("fill", "none")
    		//couleur des lignes
        .attr("stroke", function(d){ return color(d.key) })
        //épaisseur des lignes
    		.attr("stroke-width", 1.5)
        .attr("d", function(d){
        console.log("function : " + d.values);
          return d3.line()
            .x(function(d) { return x(d
                                      .dates[0]
                                      .date); })
            .y(function(d) { return y(+d
                                      .dates[0]
                                      .nb_musique); })
            (d.values)
        })
    
    // Add the line
    /*svg.append("path")
      .datum(newData)
      .attr("fill", "none")
      .attr("stroke", "steelblue")
      .attr("stroke-width", 1.5)
      .attr("d", d3.line()
        .x(function(d) { return x(d.date) })
        .y(function(d) { return y(d.nb_musique) })
        )*/
	};
  
  
  

let newData = new Array();
  
//Lecture des données
/*d3.json("data.json").then((data) => { 
  let i = 0;
  //Trier les données
  data.forEach(function(d){    
    let isPresent = false;
  	let j = 0;
    let index;
    newData.forEach(function(dd){      
      if(newData[j].genre == data[i].genre){
        isPresent = true;
        index = j;
      }      
    	j++;
    });
    
    if(isPresent){
      newData[index].nb_musique = newData[index].nb_musique+1;
    }
    else{
      
      if(!data[i].genre ==""){
        if(!data[i].dateRelease ==""){
          const date = new Date(data[i].dateRelease);
          newData.push({
                 "genre": data[i].genre,
                 "nb_musique" : 1,
                 "date": date.getFullYear()
          });
        }
      }
    }
    isPresent = false;
    i++;
    
    //Trier les dates par ordre croissant 
  	newData.sort(function (a, b) {
            return d3['ascending'](
              +a.date,
              +b.date
            );
    })
    
  });*/
  
  
  
  d3.json("data.json").then((data) => { 
  /*let i = 0;
  //Trier les données
  data.forEach(function(d){    
    let genreIsPresent = false;
  	let jGenre = 0;
    let indexGenre;
    newData.forEach(function(dd){      
      if(newData[jGenre].genre == data[i].genre){
        genreIsPresent = true;
        indexGenre = jGenre;
      }
    	jGenre++;
    });
    
    if(genreIsPresent){
      newData[indexGenre].dates[0].nb_musique = newData[indexGenre].dates[0].nb_musique+1;
    }
    else{
      
      if(!data[i].genre ==""){
        if(!data[i].dateRelease ==""){
          
          const date = new Date(data[i].dateRelease);
          newData.push({
                 "genre": data[i].genre,
            		 "dates" : [{
                  "date": date.getFullYear(),
                 	"nb_musique" : 1}]
          });
          
          
          
          
        }
      }
    }
    genreIsPresent = false;
    i++;
    
    
    //Trier les dates par ordre croissant 
  	newData.sort(function (a, b) {
            return d3['ascending'](
              +a
              .dates[0]
              .date,
              +b
              .dates[0]
              .date
            );
    })
    
  });*/
    
  
  let i = 0;
  //Trier les données
  data.forEach(function(da){
    let genre = da.genre;
    const date = new Date(da.dateRelease);
    let year = date.getFullYear();
    console.log(newData);
    if (newData.length == 0){
      let listAnnee = new Array();
        listAnnee.push({
              "date": year,
              "nb_musique":1
          })
        newData.push({
          "genre": genre,
          "dates": listAnnee
        })
    }
    newData.forEach(function(newdata){
      console.log("1");
      if(newdata.genre == da.genre){
        console.log("0");
        newdata.dates.forEach(function(years){
          console.log("2");
          if(years.date == year){
            console.log("4");
            years.nb_musique++; 
          } else {
            // if dernier element du foreach:
            console.log(years);
            newData.push({
              "date": year,
              "nb_musique": 1
              })
          	}
        	})
      }else{
        // check si dernier element du foreach
        console.log("3");
        let listAnnee = new Array();
        listAnnee.push({
              "date": year,
              "nb_musique":1
          })
        newData.push({
          "genre": genre,
          "dates": listAnnee
        })
      }
    });
  });
    
  
  console.log(newData);
  //console.log(newData[0].dates[0].nb_musique);
	update(newData);
  
})
  
  
  
  
  
}(d